# -*- encoding: utf-8 -*-

Gem::Specification.new do |s|
  s.name        = "gherkin"
  s.version     = "2.4.5"
  s.authors     = ["Mike Sassak", "Gregory Hnatiuk", "Aslak Hellesøy"]
  s.description = "A fast Gherkin lexer/parser for based on the Ragel State Machine Compiler."
  s.summary     = "#{s.name}-#{s.version}"
  s.email       = "cukes@googlegroups.com"
  s.homepage    = "http://github.com/cucumber/gherkin"

  specfiles           = Dir[ "spec/gherkin/fixtures/*.feature",
                             "spec/gherkin/fixtures/*.json",
                             "spec/gherkin/formatter/*.rb", "spec/gherkin/*.rb",
                             "spec/gherkin/parser/parser_spec.rb",
                             "spec/gherkin/shared/*.rb", "spec/*.rb" ]
  featurefiles        = Dir[ "features/*.feature", "features/*.rb" ]
  
  s.files             = Dir[ "Gemfile", "History.txt", "LICENSE",
                             "README.rdoc", "Rakefile", "VERSION",
                             "build_native_gems.sh", "cucumber.yml",
                             "gherkin.gemspec", "lib/*.rb", "lib/*.yml",
                             "lib/gherkin/formatter/*.rb",
                             "lib/gherkin/lexer/*.rb",
                             "lib/gherkin/listener/*.rb",
                             "lib/gherkin/native/*.rb",
                             "lib/gherkin/parser/*.txt",
                             "lib/gherkin/parser/*.rb",
                             "lib/gherkin/rb_lexer/README.rdoc", "ragel/*.erb",
                             "tasks/bench/*.rb",
                             "tasks/*.rake" ] + specfiles + featurefiles
  s.test_files        = specfiles + featurefiles

  s.rdoc_options     = ["--charset=UTF-8"]
  s.require_path     = "lib"

  if ENV['GEM_PLATFORM']
    puts "GEM_PLATFORM:#{ENV['GEM_PLATFORM']}"
  end
  s.platform = ENV['GEM_PLATFORM'] if ENV['GEM_PLATFORM'] 
  case s.platform.to_s
  when /java/
    s.files += Dir['lib/*.jar']
  when /mswin|mingw32/
    s.files += Dir['lib/*/*.so']
  when /dotnet/
    s.files += Dir['lib/*.dll']
  else # MRI or Rubinius
    s.files += Dir['lib/gherkin/rb_lexer/*.rb']
    s.files += Dir['ext/**/*.c']
    s.extensions = Dir['ext/**/extconf.rb']
    s.add_development_dependency('rake-compiler', '>= 0.7.8')
  end

  s.add_dependency('json', '>= 1.4.6')

  s.add_development_dependency('cucumber', '>= 1.0.0')
  s.add_development_dependency('rake', '>= 0.9.2')
  s.add_development_dependency('bundler', '>= 1.0.15')
  s.add_development_dependency('rspec', '>= 2.6.0')
  s.add_development_dependency('awesome_print', '>= 0.4.0')

  unless ENV['RUBY_CC_VERSION'] || defined?(JRUBY_VERSION)
    s.add_development_dependency('therubyracer', '>= 0.9.2') if ENV['GHERKIN_JS']
    # For Documentation:
    s.add_development_dependency('yard', '>= 0.7.2')
    s.add_development_dependency('rdiscount', '>= 1.6.8')
  end

  # Only needed by Cucumber. Remove when Cucumber no longer needs those.
  s.add_development_dependency('term-ansicolor', '>= 1.0.5')
  s.add_development_dependency('builder', '>= 2.1.2')
end
